/**********************************************************
* Author: 
*        Victorino Sanz 
*        Dpto. Informática y Automática, UNED
*        Juan del Rosal, 16
*        28040, Madrid
*        Spain
*        Email: vsanz@dia.uned.es
*
* Licensed by Victorino Sanz under the Modelica License 2
* Copyright © 2013, Victorino Sanz.
* 
***********************************************************/

#ifndef GNUPLOT
#define GNUPLOT

typedef struct ENV{
    int X;
    int Y;
    int agentTypes;
    double ***data;
    FILE *gp;
} ENV;

void * CreateENV (int x, int y,int agentTypes,const char *path,const char *name,int plot_range){
    FILE * gp;
    ENV *e;
    int i,j;
    
    e->X = x;
    e->Y = y;
    e->agentTypes = agentTypes;

    e->data = (double***)malloc(x*sizeof(double**));
    for(i=0;i<x;i++)
	e->data[i] = (double**)malloc(y*sizeof(double*));
    for(i=0;i<x;i++)
	for(j=0;j<y;j++)
	    e->data[i][j] = (double*)malloc(agentTypes*sizeof(double));
    
    for(i=0;i<x;i++)
	for(j=0;j<y;j++)
	    for(k=0;k<agentTypes;k++)
		e->data[i][j][k] = 0;
    
    printf("hola que tal\n");
    
#ifdef _WIN32
    e->gp = _popen(path, "w");
#else
    e->gp = popen(path, "w");
#endif
    
    if(e->gp == NULL){
	fprintf(stderr, "Oops, I can't find %s.", path);
	exit(EXIT_FAILURE);
    }    
#ifdef _WIN32
    fprintf(e->gp, "set terminal wxt persist \n");
#else
    fprintf(e->gp, "set terminal x11 \n");
#endif
    fprintf(e->gp, "set title \"%s\" \n",name);
    fprintf(e->gp, "set xrange [%d:0] \n",x);
    fprintf(e->gp, "set yrange [%d:0] \n",y);
    fprintf(e->gp, "set autoscale xy \n");
    fprintf(e->gp, "set cbrange [0:%d] \n",plot_range);

    printf("yo muy bien %p\n",gp);
    return (void *)e;
}

int DeleteENV(void *environment){
    ENV *e;

    e = (ENV*)environment;

    free(e->data);
    return 1;
}

// Function that describes the state of initialized cells (non-initialized cells will remain in the default state)
int plot(unsigned long int gpfile, double *data,int x, int y){
    FILE *gp = (FILE*)gpfile;
    int i,j;

    printf("empiezo el plot %p\n",gp);
    fprintf(gp,"plot \'-\' matrix with image\n");
    printf("continuo el plot %p\n",gp);
    for(i=0;i<x;i++){
	for(j=0;j<y;j++){
	    fprintf(gp,"%f",data[i*y+j]);
	}
	fprintf(gp,"\n ");
    }
    fprintf(gp,"\n");
    fprintf(gp,"e\n");
    fflush(gp);
    return 1;
}

#endif
